import java.awt.Toolkit;
import javax.swing.UIManager;
import java.io.File;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import jmrun.*;

public class JMRunSample extends javax.swing.JFrame {

public static final int wFrame  = 650;
  public static final int hFrame  = 160;

  public static final int xButton = wFrame - 150;
  public static final int wLabel  = wFrame - 170;

  /** Creates new form JMRunSample */
  public JMRunSample() {
    initComponents();

    this.setSize( new java.awt.Dimension( wFrame, hFrame ) );

    // --------------------- Center the window -----------------------
    int wScreen = (int) Toolkit.getDefaultToolkit().getScreenSize().getWidth();
    int hScreen = (int) Toolkit.getDefaultToolkit().getScreenSize().getHeight();
    this.setLocation( ( wScreen - wFrame ) / 2, ( hScreen - hFrame ) / 2 - hFrame );
    // ---------------------------------------------------------------
  } // JMRunSample


  private void initComponents() {
    javaWinButton = new javax.swing.JButton();
    jmRunExeButton = new javax.swing.JButton();
    jmRunExeSyncButton = new javax.swing.JButton();
    jmRunExeSyncFileButton = new javax.swing.JButton();

    javaWinLabel = new javax.swing.JLabel(
      "Start Win Application (notepad.exe)"
    );
    jmRunExeLabel = new javax.swing.JLabel(
      "Start Dos Application (jmrun_dos.bat) without synchronization"
    );
    jmRunExeSyncLabel = new javax.swing.JLabel(
      "Start Dos Application (jmrun_dos_sync.bat) with 'pref' synchronization in a separate Java thread"
    );
    jmRunExeSyncFileLabel = new javax.swing.JLabel(
      "Start Dos Application (jmrun_dos_sync_file.bat) with 'file' synchronization in main Java thread"
    );

    getContentPane().setLayout(null);

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setTitle("JMRunSample");

    //------------------------------------------------------------------
    javaWinButton.setText("javaExe");
    javaWinButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        javaWinButtonAp(evt);
      }
    });
    getContentPane().add(javaWinButton);
    javaWinButton.setBounds(xButton, 10, 124, 23);

    getContentPane().add(javaWinLabel);
    javaWinLabel.setBounds(10, 10, wLabel, 23);
    //------------------------------------------------------------------

    //------------------------------------------------------------------
    jmRunExeButton.setText("JMRunExe");
    jmRunExeButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jmRunExeButtonAp(evt);
      }
    });
    getContentPane().add(jmRunExeButton);
    jmRunExeButton.setBounds(xButton, 40, 124, 23);

    getContentPane().add(jmRunExeLabel);
    jmRunExeLabel.setBounds(10, 40, wLabel, 23);
    //------------------------------------------------------------------

    //------------------------------------------------------------------
    jmRunExeSyncButton.setText("jmRunExeSync");
    jmRunExeSyncButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jmRunExeSyncButtonAp(evt);
      }
    });
    getContentPane().add(jmRunExeSyncButton);
    jmRunExeSyncButton.setBounds(xButton, 70, 124, 23);

    getContentPane().add(jmRunExeSyncLabel);
    jmRunExeSyncLabel.setBounds(10, 70, wLabel, 23);
    //------------------------------------------------------------------

    //------------------------------------------------------------------
    jmRunExeSyncFileButton.setText("jmRunExeSyncFile");
    jmRunExeSyncFileButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jmRunExeSyncFileButtonAp(evt);
      }
    });
    getContentPane().add(jmRunExeSyncFileButton);
    jmRunExeSyncFileButton.setBounds(xButton, 100, 124, 23);

    getContentPane().add(jmRunExeSyncFileLabel);
    jmRunExeSyncFileLabel.setBounds(10, 100, wLabel, 23);
    //------------------------------------------------------------------
  } // initComponents

  //  private void javaWinButtonAp(java.awt.event.ActionEvent evt) {
  //    System.out.println( "javaWinButtonAp - start" );
  //    String command[] = { "cmd", "/c ", ".\\javarun.bat " + "javarun.bat-Hello" };
  //    try {
  //      Runtime.getRuntime().exec( command, null, new File( "./" ) );
  //    } catch (Exception ex) {
  //      System.out.println( "javaWinButtonAp: ex =" + ex );
  //    } // try
  //    System.out.println( "javaWinButtonAp - return" );
  //  } // javaWinButtonAp

  private void javaWinButtonAp(java.awt.event.ActionEvent evt) {
    // System.out.println( "javaWinButtonAp - start" );
    JMRun.execParam( "notepad.exe" );
    // System.out.println( "javaWinButtonAp - return" );
  } // javaWinButtonAp

  private void jmRunExeButtonAp(java.awt.event.ActionEvent evt) {
    // System.out.println( "jmRunExeButtonAp - start" );
    JMRun.execParam( "cmd /c " + ".\\jmrun_dos.bat " + "jmrun.bat-Hello" );
    // System.out.println( "jmRunExeButtonAp - return" );
  } // jmRunExeButtonAp

  private static String dosSyncKey         = "dosSyncKey";
  private static String dosSyncPath        = ".";
  private static long   dosWaitTime        = 5000;
  private static long   dosSleepTime       = 100;

  private void jmRunExeSyncButtonAp(java.awt.event.ActionEvent evt) {
    Thread proc = new Thread() {
      public void run() {
        // System.out.println( "jmRunExeSyncButtonAp - start" );

        javax.swing.JFrame waitFrame = new javax.swing.JFrame( "jmrun_sync.bat Wait Frame" );
        waitFrame.getContentPane().setLayout(null);
        int wWaitFrame = 300;
        int hWaitFrame = 100;
        waitFrame.setSize( new java.awt.Dimension( wWaitFrame, hWaitFrame ) );
        int wScreen = (int) Toolkit.getDefaultToolkit().getScreenSize().getWidth();
        int hScreen = (int) Toolkit.getDefaultToolkit().getScreenSize().getHeight();
        waitFrame.setLocation(
          ( wScreen - wWaitFrame ) / 2,
          10
        );
        waitFrame.setVisible( true );

        JMRun.execWaitPref(
          "cmd /c " + ".\\jmrun_sync.bat " + "jmrun_sync.bat-Hello",
          dosSyncKey, true, dosWaitTime, dosSleepTime
        );

        waitFrame.setVisible( false );
        waitFrame.dispose();

        // System.out.println( "jmRunExeSyncButtonAp - return" );
      } // run
    }; // class Thread
    proc.start();
  } // jmRunExeSyncButtonAp

  private void jmRunExeSyncFileButtonAp(java.awt.event.ActionEvent evt) {
    // System.out.println( "jmRunExeSyncFileButtonAp - start" );
    JMRun.execWait(
      "cmd /c " + ".\\jmrun_sync_file.bat " + "jmrun_sync_file.bat-Hello",
      dosSyncPath, true, dosWaitTime, dosSleepTime
    );
    // System.out.println( "jmRunExeSyncFileButtonAp - return" );
  } // jmRunExeSyncFileButtonAp

  /**
    * @param args the command line arguments
    */
  public static void main( String args[] ){
    try {
      UIManager.setLookAndFeel( "com.sun.java.swing.plaf.windows.WindowsLookAndFeel" );
    } catch( Exception ex ) {
    }
    java.awt.EventQueue.invokeLater(new Runnable() {
      public void run() {
        new JMRunSample().setVisible(true);
      }
    });
  } // main

  private javax.swing.JButton javaWinButton;
  private javax.swing.JButton jmRunExeButton;
  private javax.swing.JButton jmRunExeSyncButton;
  private javax.swing.JButton jmRunExeSyncFileButton;

  private javax.swing.JLabel  javaWinLabel;
  private javax.swing.JLabel  jmRunExeLabel;
  private javax.swing.JLabel  jmRunExeSyncLabel;
  private javax.swing.JLabel  jmRunExeSyncFileLabel;

} // class JMRunSample
